Package org.apache.groovy.contracts.ast.visitor

# Class ContractElementVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.apache.groovy.contracts.ast.visitor.BaseVisitor
org.apache.groovy.contracts.ast.visitor.ContractElementVisitor

All Implemented Interfaces:
  `ASTNodeMetaData`, `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class ContractElementVisitor extends BaseVisitor implements ASTNodeMetaData
Checks whether the given `ClassNode` is relevant for further processing.

- ## Field Summary

  ### Fields inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `GCONTRACTS_ENABLED_VAR, sourceUnit`

  ### Fields inherited from interface org.apache.groovy.contracts.ast.visitor.ASTNodeMetaData

  `CLOSURE_REPLACED, PROCESSED`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ContractElementVisitor(SourceUnit sourceUnit, ReaderSource source)`
  Creates a visitor that detects whether a class participates in contract processing.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `isFoundContractElement()`
  Indicates whether any contract element was detected while traversing the class hierarchy.
  `void`
  `visitClass(ClassNode node)`
  Visits the supplied class and its hierarchy until any contract element is found.
  `protected void`
  `visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)`
  Checks whether the visited constructor or method already has rewritten contract metadata.

  ### Methods inherited from class org.apache.groovy.contracts.ast.visitor.BaseVisitor

  `asConditionExecution, getOriginalCondition, getReplacedCondition, getSourceUnit, replaceCondition`

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop, visitYieldStatement`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitchExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Constructor Details

  - ### ContractElementVisitor

    public ContractElementVisitor(SourceUnit sourceUnit, ReaderSource source)
    Creates a visitor that detects whether a class participates in contract processing.
    Parameters:
      `sourceUnit` - the source unit currently being transformed
      `source` - the reader source backing the source unit

- ## Method Details

  - ### visitClass

    public void visitClass(ClassNode node)
    Visits the supplied class and its hierarchy until any contract element is found.
    Specified by:
      `visitClass` in interface `GroovyClassVisitor`
    Overrides:
      `visitClass` in class `ClassCodeVisitorSupport`
    Parameters:
      `node` - the class to inspect

  - ### visitConstructorOrMethod

    protected void visitConstructorOrMethod(MethodNode methodNode, boolean isConstructor)
    Checks whether the visited constructor or method already has rewritten contract metadata.
    Overrides:
      `visitConstructorOrMethod` in class `ClassCodeVisitorSupport`
    Parameters:
      `methodNode` - the method or constructor being inspected
      `isConstructor` - whether the node represents a constructor

  - ### isFoundContractElement

    public boolean isFoundContractElement()
    Indicates whether any contract element was detected while traversing the class hierarchy.
    Returns:
      `true` once a contract element has been found